/*
 * fca_rreq.cc -- Helen J. Wang
 * repair request and reply classes
 */

#include "fca-rreq.h"

static class FCARepairRequestClass : public TclClass {
public:
  FCARepairRequestClass() : TclClass ("FCARepairRequest") {
    Debug (dbgFCA, ("created FCARepairRequest class: %s \n", classname_));
  }
  TclObject* create (int /*argc*/, const char*const* /*argv*/) {
    return (new FCARepairRequest);
  }
} fcaRequest;


// cancel after asking for 10 times
// static const cNumMaxRreq = 20; 
int FCARepairRequest::fill_ADU(u_char* pb, int len)
{
  if (this->Packetize(pb, len)==FALSE) {
    Debug (dbgFCA, ("unable to packetize repair request"));
    return 0;
  }
  static char buffer[10000];
  *buffer = '\0';
  for (int i=0; i<len; i++) {
    sprintf (buffer, "%s%02x ", buffer, pb[i]);
  }
//  Debug (dbgFCA, ("%s", buffer));
  return len;
}


int FCARepairRequest::command(int /*argc*/, const char*const* argv) {
  if (!strcmp(argv[1], "cancel")) {
    this->cancel();
    Tcl::instance().resultf("");
  }
  
  if (!strcmp(argv[1], "backoff")) {
    this->Backoff();
    Tcl::instance().resultf("");
  }
  return TCL_OK;
}



/***************************************************************/


static class FCARepairReplyClass : public TclClass {
public:
  FCARepairReplyClass () : TclClass ("FCARepairReply") {
    Debug (dbgFCA, ("created FCARepairReply class: %s \n", classname_));
  }
  TclObject* create (int /*argc*/, const char*const* /*argv*/) {
    return (new FCARepairReply);
  }
} fcaReply;


int FCARepairReply::fill_ADU(Byte* pb, int len) 
{
  if (this->Packetize(pb, len)==FALSE) {
    Debug (dbgFCA, ("unable to packetize repair reply"));    
    return 0;
  }
  Debug(dbgFCA, ("FCARepairReply::fill_ADU contains %d bytes:", len));
  static char buffer[10000];
  *buffer = '\0';
  for (int i=0; i<len; i++) {
    sprintf (buffer, "%s%02x ", buffer, pb[i]);
  }
//  Debug (dbgFCA, ("%s", buffer));
  return len;
}


int FCARepairReply::command(int /*argc*/, const char*const* argv) {
  if (!strcmp(argv[1], "cancel")) {
    this->cancel();
    Tcl::instance().resultf("");
  }
  
  if (!strcmp(argv[1], "backoff")) {
    this->Backoff();
    Tcl::instance().resultf("");
  }
  return TCL_OK;
}


