#ifndef mc_request_h
#define mc_request_h

#include "mc/manager-mc.h"

class MC_Request : public SRM_Request {
public:
	MC_Request(MC_Manager *mcmgr, char *key) {
		key_ = new char[strlen(key) + 1];
		mcmgr_ = mcmgr;
		strcpy(key_, key);
	}
	~MC_Request(void) {
		delete[] key_;
	}
	virtual int fill_ADU(void);

private: 
	char *key_;
	MC_Manager *mcmgr_; 
};

/*
 * Packet header format for an srm cache packet
 * XXX we should leverage the SRM ADU name, but we don't.
 * 32-bit offset
 * 32-bit length
 * 16-bit key length
 * key
 * data
 *
 * XXX take keylen out of hdr; use \0. that's what we use for prefix. 
 */
class RequestPair {
public:
	void offset(u_int32_t offset) {offset_ = offset;}
	void length(int32_t length) {length_ = length;}
	u_int32_t offset(void) {return offset_;}
	int32_t length(void) {return length_;}
private:
	u_int32_t offset_;
	int32_t length_;
};


#endif // mc_request_h
