/*
 * Copyright (c) 1998 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *       This product includes software developed by the Computer Systems
 *       Engineering Group at Lawrence Berkeley Laboratory.
 * 4. Neither the name of the University nor of the Laboratory may be used
 *    to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * ---------------------------
 *
 * Filename: ztrace.h
 *   -- Created on Tue Nov 17 1998
 *   -- Author: Kristin Wright <kwright@cs.utah.edu>
 *
 * Description:
 *      Buffer output until a SIGINT is caught; when caught, flush
 *      the output and exit. The implementation that allows the ZTrace
 *      object to be "compiled away" is from Yatin's MTrace impl.
 * 
 */

#ifndef lint
static const char *rcsid = "@(#) $Header: /usr/src/mash/repository/mash/mash-1/misc/ztrace.h,v 1.1 1998/11/20 23:29:49 kwright Exp $";
#endif

#ifndef MASH_ZTRACE_H
#define MASH_ZTRACE_H

#ifdef ZTRACE

#include <stdarg.h>
#include <tclcl.h>

/*
 * This object only exists if ZTrace is defined 
 */
class ZTraceObject : public TclObject {
public:
	void flush(void);
	int command(int argc, const char*const* argv);

private:
	char *buffer_;
	unsigned buflen_;
};

#endif // ZTRACE

#endif // MASH_ZTRACE_H

