#include "tclcl.h"
#include "quantify.h"

class QuantCntrl : public TclObject {
public:
  QuantCntrl() : TclObject() {};
  
  int command (int argc, const char*const*argv);
};

static QuantCntrl quant_cntrl;
  
int QuantCntrl::command (int argc, const char*const*argv) {
  Tcl&tcl = Tcl::instance();

  if (argc == 2) {
    if (strcmp(argv[1], "is_running") == 0) {
      if (quantify_is_running()) {
	tcl.result("1");
      } else {
	tcl.result("0");
      }
      return (TCL_OK);
    }
    if (strcmp(argv[1], "start_recording") == 0) {
      quantify_start_recording_data();
      return (TCL_OK);
    }
    if (strcmp(argv[1], "stop_recording") == 0) {
      quantify_stop_recording_data();
      return (TCL_OK);
    }
    if (strcmp(argv[1], "is_recording") == 0) {
      if (quantify_is_recording_data()) {
	tcl.result("1");
      } else {
	tcl.result("0");
      }
      return (TCL_OK);
    }
    if (strcmp(argv[1], "start_recording_system") == 0) {
      quantify_start_recording_system_calls();
      return (TCL_OK);
    }
    if (strcmp(argv[1], "stop_recording_system") == 0) {
      quantify_stop_recording_system_calls();
      return (TCL_OK);
    }
    if (strcmp(argv[1], "is_recording_system") == 0) {
      if (quantify_is_recording_system_calls()) {
	tcl.result("1");
      } else {
	tcl.result("0");
      }
      return (TCL_OK);
    }
    if (strcmp(argv[1], "save") == 0) {
      quantify_save_data();
      return (TCL_OK);
    }
    if (strcmp(argv[1], "clear") == 0) {
      quantify_clear_data();
      return (TCL_OK);
    }

  }
  if (argc == 3) {
    if (strcmp(argv[1], "save") == 0) {
      quantify_save_data_to_file(argv[2]);
      return (TCL_OK);
    }
    if (strcmp(argv[1], "annotate") == 0) {
      quantify_add_annotation(argv[2]);
      return (TCL_OK);
    }
  }
  return TclObject::command(argc, argv);
}

/*
 * OTcl class binding to get name of well known
 * quantify control object
 */

static class QuantifyCntrlClass : public TclClass {
public:
  QuantifyCntrlClass() : TclClass("QuantifyControl") {}
  TclObject *create(int argc, const char*const* argv) {
    return ((TclObject *) (&quant_cntrl));
  }
} quant_cntrl_class_;


