import WebPoller/Periodic

Class WebPoller/CheckFree -superclass WebPoller/Periodic

WebPoller/CheckFree instproc init { boss } {
	$self instvar boss_ sent_ dir_ 
	
	set url "http://qs.secapl.com/cgi-bin/qs"
	#set period 30000
	set period 1
	set dir_ "/tmp"
	set boss_ $boss
	if [file exists ${dir_}/sent-checkfree.txt] {
		set sf [open ${dir_}/sent-checkfree.txt r]
		while { [gets $sf line] >= 0 } {
			set sent_([lindex $line 0]) [lrange $line 1 end]
		}
		close $sf
	}
		
	$self next $dir_ $url ""
	$self init_symbols 
	$self init_timer $period

	$self set interval_ 0
}

WebPoller/CheckFree instproc init_symbols { } {
	$self instvar symbols_

	set filename "/h/twong/src/mash-1/tcl/applications/stockcast/ds.txt"
	if [file exists $filename] {
		set sf [open $filename r]
		while { [gets $sf line] >= 0 } {
			lappend symbols_ $line
		}
		close $sf
	}
}

WebPoller/CheckFree instproc add_symbols { l } {
	$self instvar symbols_
	set symbols_ [concat $symbols_ $l]
}

WebPoller/CheckFree instproc get_data_size { } {
	# XXX dynamically calculate data size
	return 800
}

WebPoller/CheckFree instproc get { } {
	$self instvar symbols_ sent_ dir_

	for { set i 0 } { $i < [llength $symbols_] } { incr i 5 } {
		$self get_five [lrange $symbols_ $i [expr $i + 4]]
	}

	# fsync to disk
	set sf [open ${dir_}/sent-checkfree.txt w]
	foreach s [array names sent_] {
		puts $sf "$s $sent_($s)"
	}
	close $sf
}

WebPoller/CheckFree instproc get_five { list } {
	$self instvar dir_ url_
	
	set query "tick=[lindex $list 0]+[lindex $list 1]+[lindex $list 2]+[lindex $list 3]+[lindex $list 4]"
	#puts "query: $query"

	set fn "${dir_}/stocks-[clock seconds]"
	set out [open $fn w]
	set token [::http::geturl $url_ -channel $out -query $query]
	set status [::http::status $token]
	close $out

	if { "$status" == "ok" } {
		$self handle $fn $list
		file delete -force $fn 
	}
}

WebPoller/CheckFree instproc handle { filename list } {
	$self instvar boss_ sent_ 

	set buffer [open $filename r]
	set len [llength $list]
	set idx 0
	while { [gets $buffer line] >= 0 } {
		if [regexp {<td align=left><a href=http://qs-alt.secapl.com/cgi-bin/qs\?tick=[A-Z]+>([A-Z]+)</a></td>} $line match symbol] {

			# last
			gets $buffer line
			regexp {<td align=right><strong>([^<]+)</strong></td>} $line match last
			
			# change
			gets $buffer line
			regexp {<td align=right><font[^>]*>([^<]+)</font></td>} $line match change
			# percentage
			gets $buffer line
			regexp {<td align=right><font[^>]*>([^<]+)</font></td>} $line match percent

			# volume, number of trades, bid, ask
			gets $buffer line
			regexp {<td align=right>([^<]+)<br>([^<]+)</td><td align=right>([^<]+)<br>([^<]+)</td>} $line match vol trade bid ask
			
			# low, high
			gets $buffer line
			regexp {<td align=right>([^<]+)<br>([^<]+)</td>} $line match low high
			
			# prev, open
			gets $buffer line
			regexp {<td align=right>([^<]+)<br>([^<]+)</td>} $line match prev open
			
			# 52week low, high
			gets $buffer line
			regexp {<td align=right>([^<]+)<br>([^<]+)</td>} $line match low52 high52
			
			# eps, div
			gets $buffer line
			regexp {<td align=right>([^<]+)<br>([^<]+)</td>} $line match eps div
			
			# date, time
			gets $buffer line
			regexp {<td align=left>([^<]+)<br>([^<]+)</td>} $line match date time
			
			set data [list $last $change $percent $vol $trade $bid $ask $low $high $prev $open $low52 $high52 $eps $div $date $time]
			set sentence "Stock quotes for symbol $symbol at date $date, and time $time. It is last traded at $last. It has changed $change dollars and $percent percent. The current volume is $vol, and the number of trades today is $trade. It opened at $open, with previous close at $prev. The 52 week low is $low52 and the 52 week high is $high52."

			#if { ![info exists sent_] || \
			#	![info exists sent_($symbol)] || \
			#	![string match $data $sent_($symbol)] } {
			
				set sent_($symbol) $data
				$boss_ send_data $symbol $data
			#}
			
			incr idx
			if { $idx == $len } {
				break
			}
		}
	}
	
	close $buffer
}

